<form [formGroup]="formdata" novalidate (ngSubmit)="addDog(formdata.value)" #formDirective="ngForm">
    <div class="formcontrol">
      <mat-form-field>
          <input matInput type='text' name='text' formControlName="fullname" placeholder='FullName'>
          <mat-error *ngIf="formdata.invalid">Fullname is required</mat-error>
        </mat-form-field>
    </div>
   
    <div class="formcontrol">
      <mat-form-field>
          <input matInput type='text' name='text' formControlName="rasa" placeholder='Rasa'>
          <mat-error *ngIf="formdata.invalid">Rasa is required</mat-error>
        </mat-form-field>
    </div>
  <button mat-raised-button color="primary" type='submit'>Submit</button>
</form>

<div class='dog-list'>
    <ul>
      <mat-spinner *ngIf='loading'></mat-spinner>
      <div *ngIf='loaded'>
          <div class='dog' *ngFor="let dog of (dogs$ | async); let i = index">
              <p>FullName: {{ dog.fullname }}</p> 
              <p>Rasa: {{ dog.rasa }}</p>
              
              <button mat-raised-button color="primary" (click)='deleteDog(dog)'>Delete</button>
              
              <form autocomplete='off' class='editGroupForm' [formGroup]="editDogGroup" novalidate (ngSubmit)='editDog(dog, i)'>
                <div formArrayName="editForm">
                    <div formGroupName="{{ i }}">
                      <mat-form-field>
                          <input matInput type="text" name='fullname' placeholder="Edit Name" required formControlName="fullname">
                        </mat-form-field>
                        <mat-form-field>
                          <input matInput type="text" placeholder="Edit Rasa" required formControlName="rasa">
                        </mat-form-field>
                      
                        <button mat-raised-button color="primary" type='submit' [disabled]="!editDogGroup.get('editForm').at(i).valid">Edit Dog</button>
                    </div>
                  </div>
              </form>
            </div>
      </div>
    </ul>
</div>
